// 2016/12/20 （MEGA用OK）
// Due002_Temp_and_I2C_LCD と Due007_Clock_Read を
// 合成した。
// タイマー関係は時分秒のみとした。
// COM側への出力はコメント処理で止めている。
// 時間調整　プラス・マイナス１秒を + - でCOMから入力する
// 注意：桁上がり桁下がりを考慮していないため、３０秒前後の時に実行
// DS3231 を使用。ライブラリーは、DS1307
//
//

#include <Wire.h>
#include <Time.h>
#include <DS1307RTC.h>

#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x3f, 16, 2);

const char *monthName[12] = {
  "Jan", "Feb", "Mar", "Apr", "May", "Jun",
  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};
// スイッチサイエンス社のBME280サンプルスケッチ
#define BME280_ADDRESS 0x76
unsigned long int hum_raw, temp_raw, pres_raw;
signed long int t_fine;

uint16_t dig_T1;
int16_t dig_T2;
int16_t dig_T3;
uint16_t dig_P1;
int16_t dig_P2;
int16_t dig_P3;
int16_t dig_P4;
int16_t dig_P5;
int16_t dig_P6;
int16_t dig_P7;
int16_t dig_P8;
int16_t dig_P9;
int8_t  dig_H1;
int16_t dig_H2;
int8_t  dig_H3;
int16_t dig_H4;
int16_t dig_H5;
int8_t  dig_H6;

tmElements_t tm;

#define SerialOutFlag false  // シリアル出力する場合は true 、出力しない false
int b4sec;    // 前回表示した秒値を格納。
void setup()
{
pinMode(13, OUTPUT);
   digitalWrite(13, LOW);
  /*
    bool parse = false;
    bool config = false;

    // get the date and time the compiler was run
    if (getDate(__DATE__) && getTime(__TIME__)) {
      parse = true;
      // and configure the RTC with this info
      if (RTC.write(tm)) {
        config = true;
      }
    }
  */
  //LCD初期設定
  lcd.init();                      // initialize the lcd
  lcd.backlight();

  // ここを復元すればCOM側に出力する。
  Serial.begin(9600);

  //BME280初期設定
  uint8_t osrs_t = 1;             //Temperature oversampling x 1
  uint8_t osrs_p = 1;             //Pressure oversampling x 1
  uint8_t osrs_h = 1;             //Humidity oversampling x 1
  uint8_t mode = 3;               //Normal mode
  uint8_t t_sb = 5;               //Tstandby 1000ms
  uint8_t filter = 0;             //Filter off
  uint8_t spi3w_en = 0;           //3-wire SPI Disable

  uint8_t ctrl_meas_reg = (osrs_t << 5) | (osrs_p << 2) | mode;
  uint8_t config_reg    = (t_sb << 5) | (filter << 2) | spi3w_en;
  uint8_t ctrl_hum_reg  = osrs_h;
  // I2CのSETUP
  Wire.begin();
  writeReg(0xF2, ctrl_hum_reg);
  writeReg(0xF4, ctrl_meas_reg);
  writeReg(0xF5, config_reg);
  readTrim();                    //
  /*
    // I2C_LCDに初期表示する
    lcd.setCursor(4, 0);
    lcd.print("c");
    lcd.setCursor(12, 0);
    lcd.print("%");
    lcd.setCursor(6, 1);
    lcd.print("h");
  */
}

void loop()
{
  char SS;
  if (RTC.read(tm)) {    // RTCから時間が読み出せれば◆
    // 時間調整　プラス・マイナス１秒を + - でCOMから入力する
    // 注意：秒が３０秒前後の時に実行すること
    // （簡易設定のため、桁上がり桁下がりを考慮せず）
    while (Serial.available() > 0) { // 受信したデータが存在する
      SS = Serial.read();  // 受信データを読み込む
      if (SS == '+') { // 受信データがプラスなら？
        tm.Second++;
        // and configure the RTC with this info
        RTC.write(tm);    // 時間をDS3231 へセットする
      }
      if (SS == '-') { // 受信データがマイナスなら？
        tm.Second--;
        // and configure the RTC with this info
        RTC.write(tm);    // 時間をDS3231 へセットする
      }
    }
  } else {    // RTCから時間が読み出せ無ければ◆
    if (RTC.chipPresent()) {
      lcd.setCursor(0, 0);
      lcd.print("run the SetTime");
    } else {
      lcd.setCursor(0, 0);
      lcd.print("DS1307 read error!");
    }
    delay(9000);
  }
  if (b4sec != tm.Second ) { // 取得した秒値が違えば、表示する
    b4sec = tm.Second;
    TempClockDisp();
  }
  // delay(1000);

}  // ■■■■■■■■■■■■ loopEND ■■■■■■■■■■■■

void TempClockDisp() {    // 温度・湿度・気圧・時間を表示
   digitalWrite(13, HIGH);
  // シリアル出力が必要なら
  if (SerialOutFlag == true ) {
    Serial.print("Ok, Time = ");
    print2digits(tm.Hour);
    Serial.write(':');
    print2digits(tm.Minute);
    Serial.write(':');
    print2digits(tm.Second);
    Serial.print(", Date (D/M/Y) = ");
    Serial.print(tm.Day);
    Serial.write('/');
    Serial.print(tm.Month);
    Serial.write('/');
    Serial.print(tmYearToCalendar(tm.Year)); // Start Year1970 + tm.Year = 2016
    Serial.println();
  }

  // I2C.LCD へも出力する。
  // 時分秒
  lcd.setCursor(8, 1);
  lcd2digits(tm.Hour);
  lcd.print(":");
  lcd2digits(tm.Minute);
  lcd.print(":");
  lcd2digits(tm.Second);

  /*
      // 年月日　表示エリヤの関係で使わない
      lcd.setCursor(0, 1);
      lcd.print(tmYearToCalendar(tm.Year));
      lcd.print("/");
      lcd2digits(tm.Month);
      lcd.print("/");
      lcd2digits(tm.Day);
      lcd.print(" ");
      */
  delay(100);

    // 温度・湿度・気圧を表示
    double temp_act = 0.0, press_act = 0.0, hum_act = 0.0;
    signed long int temp_cal;
    unsigned long int press_cal, hum_cal;
    int aa;

    readData();

    temp_cal = calibration_T(temp_raw);
    press_cal = calibration_P(pres_raw);
    hum_cal = calibration_H(hum_raw);
    temp_act = (double)temp_cal / 100.0;
    press_act = (double)press_cal / 100.0;
    hum_act = (double)hum_cal / 1024.0;
    //初期値が小数点以下２桁のため Serial.print(XXXXX,1); ,1 で
    //小数点以下２桁目を四捨五入し、小数点以下１桁出力とする。

    if (SerialOutFlag == true ) {
      Serial.print("  TEMP : ");
      Serial.print(temp_act, 1);
      Serial.print(" DegC  PRESS : ");
      Serial.print(press_act, 1);
      Serial.print(" hPa  HUM : ");
      Serial.print(hum_act, 1);
      Serial.println(" %");
    }
    // I2C LCD に表示する
    //初期値が小数点以下２桁のため lcd.print(XXXXX,1); ,1 で
    //小数点以下２桁目を四捨五入し、小数点以下１桁出力とする。
    lcd.setCursor(0, 0);
    lcd.print(temp_act, 1);
    lcd.print("c ");
    lcd.setCursor(8, 0);
    lcd.print(hum_act, 1);
    lcd.print("% ");
    lcd.setCursor(0, 1);
    lcd.print(press_act, 1);
    lcd.print("h ");
   digitalWrite(13, LOW);
}

// ■◆■■これ以降、タイマーDS3231関係の記述
void print2digits(int number) {
  if (number >= 0 && number < 10) {
    Serial.write('0');
  }
  Serial.print(number);
}

// LCDへの出力を２桁にする　print2digits　を参照して追加。
void lcd2digits(int number) {
  if (number >= 0 && number < 10) {
    lcd.print('0');
  }
  lcd.print(number);
}
// ■◆■■ここまで、タイマーDS3231関係の記述

////////////////////////////////////////////////////////////////
// ■■■これ以降、BME280 温度・湿度・気圧関係の記述
void readTrim()   // BME280の処理
{
  uint8_t data[32], i = 0;                   // Fix 2014/04/06
  Wire.beginTransmission(BME280_ADDRESS);
  Wire.write(0x88);
  Wire.endTransmission();
  Wire.requestFrom(BME280_ADDRESS, 24);      // Fix 2014/04/06
  while (Wire.available()) {
    data[i] = Wire.read();
    i++;
  }

  Wire.beginTransmission(BME280_ADDRESS);    // Add 2014/04/06
  Wire.write(0xA1);                          // Add 2014/04/06
  Wire.endTransmission();                    // Add 2014/04/06
  Wire.requestFrom(BME280_ADDRESS, 1);       // Add 2014/04/06
  data[i] = Wire.read();                     // Add 2014/04/06
  i++;                                       // Add 2014/04/06

  Wire.beginTransmission(BME280_ADDRESS);
  Wire.write(0xE1);
  Wire.endTransmission();
  Wire.requestFrom(BME280_ADDRESS, 7);       // Fix 2014/04/06
  while (Wire.available()) {
    data[i] = Wire.read();
    i++;
  }
  dig_T1 = (data[1] << 8) | data[0];
  dig_T2 = (data[3] << 8) | data[2];
  dig_T3 = (data[5] << 8) | data[4];
  dig_P1 = (data[7] << 8) | data[6];
  dig_P2 = (data[9] << 8) | data[8];
  dig_P3 = (data[11] << 8) | data[10];
  dig_P4 = (data[13] << 8) | data[12];
  dig_P5 = (data[15] << 8) | data[14];
  dig_P6 = (data[17] << 8) | data[16];
  dig_P7 = (data[19] << 8) | data[18];
  dig_P8 = (data[21] << 8) | data[20];
  dig_P9 = (data[23] << 8) | data[22];
  dig_H1 = data[24];
  dig_H2 = (data[26] << 8) | data[25];
  dig_H3 = data[27];
  dig_H4 = (data[28] << 4) | (0x0F & data[29]);
  dig_H5 = (data[30] << 4) | ((data[29] >> 4) & 0x0F); // Fix 2014/04/06
  dig_H6 = data[31];                                   // Fix 2014/04/06
}
void writeReg(uint8_t reg_address, uint8_t data)
{
  Wire.beginTransmission(BME280_ADDRESS);
  Wire.write(reg_address);
  Wire.write(data);
  Wire.endTransmission();
}
void readData()
{
  int i = 0;
  uint32_t data[8];
  Wire.beginTransmission(BME280_ADDRESS);
  Wire.write(0xF7);
  Wire.endTransmission();
  Wire.requestFrom(BME280_ADDRESS, 8);
  while (Wire.available()) {
    data[i] = Wire.read();
    i++;
  }
  pres_raw = (data[0] << 12) | (data[1] << 4) | (data[2] >> 4);
  temp_raw = (data[3] << 12) | (data[4] << 4) | (data[5] >> 4);
  hum_raw  = (data[6] << 8) | data[7];
}

signed long int calibration_T(signed long int adc_T)
{
  signed long int var1, var2, T;
  var1 = ((((adc_T >> 3) - ((signed long int)dig_T1 << 1))) * ((signed long int)dig_T2)) >> 11;
  var2 = (((((adc_T >> 4) - ((signed long int)dig_T1)) * ((adc_T >> 4) - ((signed long int)dig_T1))) >> 12) * ((signed long int)dig_T3)) >> 14;

  t_fine = var1 + var2;
  T = (t_fine * 5 + 128) >> 8;
  return T;
}

unsigned long int calibration_P(signed long int adc_P)
{
  signed long int var1, var2;
  unsigned long int P;
  var1 = (((signed long int)t_fine) >> 1) - (signed long int)64000;
  var2 = (((var1 >> 2) * (var1 >> 2)) >> 11) * ((signed long int)dig_P6);
  var2 = var2 + ((var1 * ((signed long int)dig_P5)) << 1);
  var2 = (var2 >> 2) + (((signed long int)dig_P4) << 16);
  var1 = (((dig_P3 * (((var1 >> 2) * (var1 >> 2)) >> 13)) >> 3) + ((((signed long int)dig_P2) * var1) >> 1)) >> 18;
  var1 = ((((32768 + var1)) * ((signed long int)dig_P1)) >> 15);
  if (var1 == 0)
  {
    return 0;
  }
  P = (((unsigned long int)(((signed long int)1048576) - adc_P) - (var2 >> 12))) * 3125;
  if (P < 0x80000000)
  {
    P = (P << 1) / ((unsigned long int) var1);
  }
  else
  {
    P = (P / (unsigned long int)var1) * 2;
  }
  var1 = (((signed long int)dig_P9) * ((signed long int)(((P >> 3) * (P >> 3)) >> 13))) >> 12;
  var2 = (((signed long int)(P >> 2)) * ((signed long int)dig_P8)) >> 13;
  P = (unsigned long int)((signed long int)P + ((var1 + var2 + dig_P7) >> 4));
  return P;
}

unsigned long int calibration_H(signed long int adc_H)
{
  signed long int v_x1;

  v_x1 = (t_fine - ((signed long int)76800));
  v_x1 = (((((adc_H << 14) - (((signed long int)dig_H4) << 20) - (((signed long int)dig_H5) * v_x1)) +
            ((signed long int)16384)) >> 15) * (((((((v_x1 * ((signed long int)dig_H6)) >> 10) *
                (((v_x1 * ((signed long int)dig_H3)) >> 11) + ((signed long int) 32768))) >> 10) + (( signed long int)2097152)) *
                ((signed long int) dig_H2) + 8192) >> 14));
  v_x1 = (v_x1 - (((((v_x1 >> 15) * (v_x1 >> 15)) >> 7) * ((signed long int)dig_H1)) >> 4));
  v_x1 = (v_x1 < 0 ? 0 : v_x1);
  v_x1 = (v_x1 > 419430400 ? 419430400 : v_x1);
  return (unsigned long int)(v_x1 >> 12);
  // ■■■ここまで、温度・湿度・気圧関係の記述
  /////////////////////////////////////////////////////////////////
}




